<?php

namespace Treewec\DirectoryIterators;

/**
 * Test class for BreadthFirstSearch.
 * Generated by PHPUnit on 2012-07-03 at 17:01:03.
 * @group directory_iterators
 */
class BreadthFirstSearchTest extends \PHPUnit_Framework_TestCase {

    /** @var BreadthFirstSearch */
    private $iterator;
    private $filenamesFromDir;

    protected function setUp() {
        $this->iterator = new BreadthFirstSearch(TEMP_FILEDIR);
        $this->filenamesFromDir = array(
            0 => array(
                'temp-files'
            ),
            1 => array(
                'existing', 'existing-žeš', 'test',
                'existing.php', 'existing-žeš.php', 'test.php'
            ),
            2 => array(
                'index.php', 'ošel'
            ),
        );
    }

    public function testIterator() {
        $count = 0;
        $lastDepth = 0;
        while($this->iterator->hasNext()) {
            $next = $this->iterator->next();
            $filename = \Treewec\FileSystem\Path::toScreen($next->splFileInfo->getFilename());
            if ($filename != 'dir.order') {
                parent::assertTrue(in_array($filename, $this->filenamesFromDir[$next->depth]));            
                // test depth - it's always equal or +1 than lastDepth
                parent::assertTrue($lastDepth == $next->depth || ($lastDepth + 1) == $next->depth);
                $lastDepth = $next->depth;
                $count++;
            }
        }
        parent::assertEquals($count, $this->getStaticCount());
    }

    private function getStaticCount() {
        $count = 0;
        foreach ($this->filenamesFromDir as $names) {
            $count += count($names);
        }
        return $count;
    }

}

?>
